;*******************************
;
; Reset-vdett program a GURU-tl
; 
;                     `Gaborca
;*******************************

;Ez egy egyszer kis demo-program amely megmutatja hogyan tudsz
;Reset-vdett programokat kszteni, a rendszerszoftver (ROM) 
;lehetsgeinek kihasznlsa nlkl.
;A program belltja a kt Reset-vektort ( "ColdStart" s "CoolStart" ).
;A ColdStart vektor mutat a fprogramra, amelyik egy szp sznes 
;Copper listt generl s rotlja rajta a szneket mg meg nem nyomod a 
;bal egrgombot. Utna visszalltja az eredeti Copper listt, DMA-t.
;A CoolStart vektor pedig egy rvid rutinra mutat, amely a programunk 
;szmra lefoglalja a memrit, hogy semmi ne rja azt fell.

;*******************************

    move.l  4,a6
    move.l  #10000,d0       ;10000 Byte lefoglalsa ezen programnak
    lea     start(pc),a1    ;start cmktl
    jsr     -$0cc(a6)       ;AllocAbs()
start:
    move.l  4,a6            ;EXEC kezdcme
    lea     reset(pc),a0    ;A fprogram kezdcme a ColdCapture vektorba
    move.l  a0,$2a(a6)
    lea     mem(pc),a0      ;Memria-Allokcis rutin kezdcme
    move.l  a0,$2e(a6)      ;a CoolCapture vektorba

    move.w  #0,$24(a6)      ;A megvltozott Checksum jraszmtsa
    moveq   #0,d1           ;azrt, hogy az EXEC ne jelezzen hibt
    lea     $22(a6),a0
    moveq   #$18,d0
sum:
    add.w   (a0)+,d1
    dbra    d0,sum
    not.w   d1
    move.w  d1,$24(a6)
    moveq   #0,d1
    lea     $22(a6),a0
    moveq   #$18,d0
sum2:
    add.w   (a0)+,d1
    dbra    d0,sum2
    not.w   d1              ;Inicializls vge
    rts

mem:
    move.l  #10000,d0       ;10000 Byte lefoglalsa ezen programnak
    lea     start(pc),a1    ;start cmktl
    jsr     -$0cc(a6)       ;AllocAbs()
    rts                     ;Memria allokci vge

;*****************************
;
; Eddg volt az inicializl rsz. Most ha a gp RESET-et kap
; a vezrls ide a reset: cimkre fog taddni.
; Ide rhatod sajt programodat.
;
;*****************************

reset:
    movem.l d0-d7/a0-a6,-(a7)       ;Regiszterek tartalmnak eltrolsa
    lea.l   $50000,a0               ;Bitplane kezdcme :$50000
    move.l  #6645,d0                ;Hossza :6645 Bytes

clear:
    clr.l   (a0)+                   ;Bitplane trlse
    dbf     d0,clear

    jsr     start                   ;Reset-vektorok jrabelltsa

    lea.l   coltab(pc),a1           ;mutat Szntblra;
    bsr     copperinit              ;Copper-lista inicializlsa
    jsr     -132(a6)                ;Forbid();
                                    ;Multitasking kikapcsolsa
    lea.l   $dff000,a5              ;a5 = Customchipbase
    move.w  #$03e0,$96(a5)          ;$96 ->DMA ->Control write

                                    ;Bit-Plane   DMA letiltva,
                                    ;Coprocessor DMA letiltva,
                                    ;Blitter     DMA letiltva,
                                    ;Sprite      DMA letiltva

    move.l  #$55000,$80(a5)         ;COP1LCH := $55000
                                    ;indirekt JMP - a Copper lokation
                                    ;regiszter $55000 -re lltsa

    clr.w   $88(a5)                 ;COPJMP1 trlse, Copper lista 
                                    ;aktivlsa
    move.w  #$1100,$100(a5)         ;BLCON0 = #$1100
    clr.l   $102(a5)                ;BLCON1 trlse
    clr.l   $108(a5)                ;BL1MOD trlse

    move.w  #$8380,$96(a5)          ;$95 ->DMA ->control write
                                    ;Bit-Plane   DMA engedlyezve,
                                    ;Coprocessor DMA engedlyezve

    move.l  #0,a2

main:
    andi.b  #64,$bfe001             ;Megnyomtk a bal egrgombot ?
    beq     end                     ;Ha igen ugrs a program vgre

    lea.l   coltab(pc),a1           ;mutat a szntblzatra
    add.l   #1,a2                   ;a2-t eggyel nvelni,
    cmp.l   #32,a2                  ;szntbla vgre rt ?
    bne     cont                    ;ha nem akkor tovbb
    move.l  #0,a2                   ;ha igen akkor az elejre ll

cont:
    adda.l  a2,a1                   ;a1=a1+a2
    bsr     copperinit              ;az j copper lista inicializlsa
    move.l  #$ff,d3                 ;idztciklus szmllja

loop:
    tst.l   (a6)                    ;Dummy
    dbra    d3,loop                 ;idztciklus
    bra     main                    ;ugrs az elejre

;***************************
;
;Ez a rsz fontos, a sajt programod vgn is szerepelnie kell 
;ha azt akarod hogy a RESET s a programod  utn a rendszer 
;is induljon.
;
;***************************

end:
    lea.l   gfxname(pc),a1          ;mutat  gfx-lib nevre az a1-ben
    jsr     -408(a6)                ;--> OldOpenLibrary();
    move.l  d0,a4                   ;rgi Copperlista visszalltsa
    move.l  38(a4),$80(a5)          ;
    clr.w   $88(a5)                 ;COPJMP1 trlse,rgi copper lista aktv
    move.w  #$8060,$96(a5)          ;Sprite s Blitter DMA
                                    ;engedlyezse

    jsr     -138(a6)                ; --> Permit();
                                    ; Multitasking bekapcsolsa

    movem.l (a7)+,d0-d7/a0-a6       ;Regiszterek tartalmnak visszalltsa
    move.l  #reset,$2a(a6)          ;Reset vektor belltsa ( mgegyszer )
    jmp     (a5)                    ;visszatrs

copperinit:
    clr.l   d1                      ;d1 trlse
    lea.l   $55000,a0               ;Copper lista kezdcme
    move.l  #$00e00005,(a0)+        ;BitPlane1 mutat belltsa
    move.l  #$00e20000,(a0)+
    move.l  #$01800f00,(a0)+        ;Color0 vrsre lltsa
    move.l  #80,d0                  ;a 80. sortl szn-rotci
loop1:
    move.b  d0,(a0)+                ;Wait - VP
    move.b  #1,(a0)+                ;Wait - HP + Bit 0 belltsa
    move.l  #$fffe0180,(a0)+        ;Wait + Color0
    clr.l   d6
    move.b  (a1,d1),d6              ;j szn a tblzatbl
    eori    #$0ff0,d6
    move.w  d6,(a0)+                ;Copper listba a Color0-hoz
    addq    #1,d1                   ;szn-tblzat index nvelse
    cmpi    #32,d1                  ;mikor 32 szn megvolt,
    bne     loop2
    clr.l   d1                      ;akkor a szn-tblzat index trlse

loop2:
    add.l   #1,d0                   ;sor=sor+1
    cmp.l   #255,d0                 ;a 255. sorig
    beq     loop3
    bra     loop1

loop3:
    move.l  #$ff01fffe,(a0)+        ;vrni a 255. sorig
    move.l  #$01800f00,(a0)+        ;majd a Color0 vrsre lltsa
    move.l  #$fffffffe,(a0)+        ;Copper lista vge
    rts                             ;visszatrs

;Szntblzat, amely 64 elembl ll ( 32+32 ) a rotci miatt.

even
coltab:
    dc.b    $00,$10,$20,$30,$40,$50,$60,$70,$80,$90
    dc.b    $a0,$b0,$c0,$d0,$e0,$f0,$f0,$e0,$d0
    dc.b    $c0,$b0,$a0,$90,$80,$70,$60,$50,$40,$30
    dc.b    $20,$10,$00,$00,$10,$20,$30,$40,$50,$60
    dc.b    $70,$80,$90,$a0,$b0,$c0,$d0,$e0,$f0,$f0
    dc.b    $e0,$d0,$c0,$b0,$a0,$90,$80,$70,$60,$50
    dc.b    $40,$30,$20,$10,$00

gfxname:dc.b "graphics.library",0

;END
